(*************************************************************************)
(*                     Modul Hauptsteuerung				 *)
(*************************************************************************)


 	(*************************************************)
	(*  Programmiert von Ulrike Schoop               *)
	(*  Aktueller Stand  : 28.April 1989             *)
	(*  Ueberarbeitet von A. Schmidt, 26.5.89        *)
	(*                                               *)
	(*        Version 2.0                            *)
	(*                                               *)
	(*************************************************)


   (*$I SCREEN.PAS*)
   (*$I zufall.pas*)
   (*$I cons_typ.pas*)
   (*$I zktypen.pas*)
   (*$I stroph2.pas*)
   (*$I gedichte.pas*)

VAR
     Werk         : tGedicht ;
     StrproGe     : tStrproGe;
     ok           : boolean;


PROCEDURE initialisiere;
  BEGIN
    (* auf ^C prfen anschalten *)
    checkbreak := TRUE;
    init(ok);
    StrproGe  := 2;
    IF NOT ok
     THEN
      BEGIN
       writeln;
       writeln('       Das Programm kann leider nicht gestartet werden !');
       writeln('        Bitte wenden Sie sich an den Service-Manager ! ');
       writeln;
      END;
  END;  (* initialisiere *)

(* ---------------------------------------------------------------------- *)

PROCEDURE Begruessung ;
 BEGIN
  loescheBildschirm;
  writeln;
  writeln;
  writeln('                        Computerdichtung  ');
  writeln;
  writeln('     Gedichtgenerator, erstellt 1989 vom Kurs in-3.2 der ');
  writeln('     Droste-Hlshoff-Oberschule in Berlin 37');
  writeln;
  writeln('     A. John, Ch. Karsten, U. Schoop, J. v.Waldhausen, R. Wilks');
  writeln;
  writeln('     berarbeitet von A. Schmidt');
  writeln;
  writeln('     Mit <RETURN> geht es los!');
  readln;
 END;  (* Begruessung *)

(* ---------------------------------------------------------------------- *)

PROCEDURE Hauptmenue ;

  VAR ende       : boolean;
      Ziffer     : char;
      x, y       : integer;
  PROCEDURE Ausgabe;
   BEGIN
    baueGedicht (Werk, StrproGe);
    schrGedicht (Werk, StrproGe);
    spGedicht (Werk, StrproGe);
   END;

  PROCEDURE Format ;
   VAR Antwort  : char;
       Zahl1
		: integer;

   BEGIN
     loescheBildschirm;
     writeln;
     writeln;
     writeln('                Format ');
     writeln;
     writeln;
     writeln('      Gedichte sollen ganz induviduell sein.Deswegen darf ');
     writeln('      jeder sein Format whlen !');
     writeln;
     writeln('      Momentan ist das Format wie folgt eingestellt :');
     writeln;
     writeln('      Strophen pro Gedicht : ',StrproGe);
     writeln;
     repeat
       set_cursor (7, 14);
       write('Mchten Sie das Format ndern (j/n)? ');
       readln(Antwort);
     UNTIL Antwort in ['j','J','n','N','Y','y'];
     IF Antwort in ['j','J','Y','y']
        THEN BEGIN
          REPEAT
            set_cursor (7, 16);
            write('Geben Sie die neue Strophenzahl ein (zwischen 1 und ', maxStrophen, '):');
            set_cursor (63, 16);
            readln(Zahl1);
          UNTIL Zahl1 in [1..maxStrophen];
          set_cursor (7, 18);
          writeln ('Die Strophenzahl betrgt jetzt: ', Zahl1);
          set_cursor (7, 20);
          writeln ('Weiter mit <RETURN>');
          readln;
          StrproGe := Zahl1;
          END; {then}
   END;  { format }

   PROCEDURE Hilfe;
    BEGIN
      loescheBildschirm;
      writeln ('Gedicht ausgeben:');
      writeln ('veranlat den Rechner, ein neues Gedicht zu verfassen und dieses');
      writeln ('anschlieend auf dem Bildschirm auszugeben.');
      writeln;
      writeln ('uere Form auswhlen:');
      writeln ('erffnet die Mglichkeit, auf die uere Form der Gedichte einen');
      writeln ('kleinen Einflu zu nehmen: Man kann die Anzahl der Strophen');
      writeln ('einstellen zwischen 1 und 2. Voreingestellt ist Anzahl = 1.');
      writeln;
      writeln ('Hilfe anzeigen:');
      writeln ('Der gerade sichtbare Text erscheint auf dem Bildschirm.');
      writeln ('Eigentlich irgendwie klar.');
      writeln;
      writeln ('Programm beenden:');
      writeln ('Eben dieses! Wenn man genug gesehen hat, verlt man so das');
      writeln ('Programm.');
      writeln;
      writeln ('Und noch etwas: Die Gedichte sind anschlieend als Textdatei');
      writeln ('mit dem Namen gedichte.txt gespeichert. Man kann sie also');
      writeln ('spter weiterverarbeiten und ganz oder teilweise ausdrucken.');
      writeln;
      writeln;
      writeln ('Weiter mit <return>');
      readln;
    END; (* hilfe *)

  BEGIN      (*   Hauptmenue *)
    Ende := FALSE;
    REPEAT
      loescheBildschirm;
      writeln;
      writeln;
      writeln;
      writeln('                         Hauptmen  ');
      writeln;
      writeln;
      writeln;
      writeln('                1    Gedicht ausgeben ');
      writeln('                2    uere Form des Gedichts auswhlen ');
      writeln;
      writeln('                3    Hilfe anzeigen  ');
      writeln('                4    Programm beenden  ');
      writeln;
      x := wherex;
      y := wherey;
      REPEAT
       set_cursor (x, y);
       write('             Bitte Ziffer eingeben :');
       set_cursor (38,14);
       readln (ziffer);
      UNTIL ziffer in ['1','2','3','4'];
      CASE Ziffer OF
	 '1'   :  Ausgabe ;
	 '2'   :  Format;
	 '3'   :  Hilfe;
	 '4'   :  ende := true ;
	END;
    UNTIL ende ;
  END;  (* hauptmenue *)

(* ---------------------------------------------------------------------- *)

PROCEDURE ciao ;
  BEGIN
   loescheBildschirm;
   writeln;
   writeln;
   writeln('      Wir danken fr Ihr Interesse und wnschen') ;
   writeln('      Ihnen noch einen schnen Tag ! ');
   writeln;
   writeln;
   writeln;
   schliesse;
  END;  (* ciao *)

(**************************************************************************)

BEGIN   (*    Hauptprogramm  *)
  loescheBildschirm;
  initialisiere;
  IF ok
     THEN
       BEGIN
	Begruessung ;
	Hauptmenue;
	ciao ;
       END
END.

