		(************************)
		(*                    	*)
    	        (*   Modul Strophen	*)
    	        (*			*)
    	        (************************)

	(*************************************************)
	(*                                               *)
	(*  Programmiert von Ralph Wilks und A. Schmidt  *)
	(*  Aktueller Stand  : 13. 6 1989                *)
	(*                                               *)
	(*        Version 2.1                            *)
	(*                                               *)
	(*************************************************)

   VAR
	  DatTitel,                 (* logische Dateinamen *)
	  DatAngst,
	  Datvieles,
	  Datstoerend,
	  Datlauernd,
	  Datunter,
	  Datroten,
	  DatSonnen,
	  Datich_bin,
	  Datallein,
	  DatGedanken,
	  Datsuchen,
	  DatHilfe,
	  ausgabe
			  : text;

	  FTitel                  (* Dateien als Felder im Arbeitsspeicher *)
			  : ARRAY [1..maxDateiEintraege] OF string40;
	  FAngst,
	  Fvieles,
	  Fstoerend,
	  Flauernd,
	  Funter,
	  Froten,
	  FSonnen,
	  Fich_bin,
	  Fallein,
	  FGedanken,
	  Fsuchen,
	  FHilfe
			  : ARRAY [1..maxDateiEintraege] OF string20;
	  AnzTitel,
	  AnzAngst,
	  Anzvieles,
	  Anzstoerend,
	  Anzlauernd,
	  Anzunter,
	  Anzroten,
	  AnzSonnen,
	  Anzich_bin,
	  Anzallein,
	  AnzGedanken,
	  Anzsuchen,
	  AnzHilfe
			  : 0..maxDateiEintraege;

	  Wort
			  : string[40];


   PROCEDURE init ( VAR ok: boolean );
      (* Initialisiert den Datenmodul, liest alle Dateien ein. Gibt        *)
      (* ok=TRUE zurueck, wenn erfolgreich, sonst ok=FALSE.                *)
   VAR
       zaehler : 0..maxDateiEintraege;
   BEGIN
     ok := TRUE;
     (*$I-*)
     assign (DatTitel, titeldat);
     reset (DatTitel);
     IF ioresult <> 0
	THEN ok := FALSE;
     IF ok
	THEN
	  BEGIN
	    AnzTitel := 0;
	    FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(DatTitel)
	       THEN
		    BEGIN
		      readln (DatTitel, FTitel [zaehler]);
		      AnzTitel := AnzTitel + 1;
		    END
	       ELSE
		    FTitel[zaehler] := ' ';
            close (DatTitel);
     assign (DatAngst, angstdat);
     reset (DatAngst);
     IF ioresult <> 0
	THEN ok := FALSE;
     assign (Datvieles, vielesdat);
     reset (Datvieles);
     IF ioresult <> 0
	THEN ok := FALSE;
     assign (Datstoerend, stoerenddat);
     reset (Datstoerend);
     IF ioresult <> 0
	THEN ok := FALSE;
     assign (Datlauernd, lauernddat);
     reset (Datlauernd);
     IF ioresult <> 0
	THEN ok := FALSE;
     assign (Datunter, unterdat);
     reset (Datunter);
     IF ioresult <> 0
	THEN ok := FALSE;
     assign (Datroten, rotendat);
     reset (Datroten);
     IF ioresult <> 0
	THEN ok := FALSE;
     assign (DatSonnen, sonnendat);
     reset (DatSonnen);
     IF ioresult <> 0
	THEN ok := FALSE;
     assign (Datich_bin, ich_bindat);
     reset (Datich_bin);
     IF ioresult <> 0
	THEN ok := FALSE;
     assign (Datallein, alleindat);
     reset (Datallein);
     IF ioresult <> 0
	THEN ok := FALSE;
     assign (DatGedanken, gedankendat);
     reset (DatGedanken);
     IF ioresult <> 0
	THEN ok := FALSE;
     assign (Datsuchen, suchendat);
     reset (Datsuchen);
     IF ioresult <> 0
	THEN ok := FALSE;
     assign (DatHilfe, hilfedat);
     reset (DatHilfe);
     IF ioresult <> 0
	THEN ok := FALSE;
     (*$I+*)
	    AnzAngst := 0;
	    FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(DatAngst)
	       THEN
		    BEGIN
		      readln (DatAngst, FAngst [zaehler]);
		      AnzAngst := AnzAngst + 1;
		    END
	       ELSE
		    FAngst[zaehler] := ' ';
	    Anzstoerend := 0;
	    FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(Datstoerend)
	       THEN
		    BEGIN
		      readln (Datstoerend, Fstoerend [zaehler]);
		      Anzstoerend := Anzstoerend + 1;
		    END
	       ELSE
		    Fstoerend [zaehler] := ' ';
	    Anzvieles := 0;
	    FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(Datvieles)
	       THEN');
      writeln ('Der gerade sichtbare Text erscheint auf dem Bildschirm.');
      writeln ('Eigentlich irgendwie klar.');
      writeln;
      writeln ('Programm beenden:');
      writeln ('Eben dieses! Wenn man genug gesehen hat, verlt man so das');
      writeln ('Programm.');
      writeln;
      writeln ('Und noch etwas: Die Gedichte sind anschlieend als Textdatei');
      writeln ('mit dem Namen gedichte.txt gespeichert. Man kann sie also');
      writeln ('spter weiterverarbeiten und ganz oder teilweise ausdrucken.');
      writeln;
      writeln;
      writeln ('Weiter mit <return>');
      readln;
    END; (* hilfe *)

  BEGIN      (*   Hauptmenue *)
    Ende := FALSE;
    REPEAT
      loescheBildschirm;
      writeln;
      writeln;
      writeln;
      writeln('                         Hauptmen  ');
      writeln;
      writeln;
      writeln;
      writeln('                1    Gedicht ausgeben ');
      writeln('                2    uere Form des Gedichts auswhlen ');
      writeln;
      writeln('                3    Hilfe anzeigen  ');
      writeln('                4    Programm beenden  ');
      writeln;
      x := wherex;
      y := wherey;
      REPEAT
       set_cursor (x, y);
       write('             Bitte Ziffer eingeben :');
       set_cursor (38,14);
       readln (ziffer);
      UNTIL ziffer in ['1','2','3','4'];
      CASE Ziffer OF
	 '1'   :  Ausgabe ;
	 '2'   :  Format;
	 '3'   :  Hilfe;
	 '4'   :  ende := true ;
	END;
    UNTIL ende ;
  END;  (* hauptmenue *)

(* ---------------------------------------------------------------------- *)

PROCEDURE ciao ;
  BEGIN
   loescheBildschirm;
   writeln;
   writeln;
   writeln('      Wir danken fr Ihr Interesse und wnschen') ;
   writeln('      Ihnen noch einen schnen Tag ! ');
   writeln;
   writeln;
   writeln;
   schliesse;
  END;  (* ciao *)

(**************************************************************************)

BEGIN   (*    Hauptprogramm  *)
  loescheBildschirm;
  initialisiere;
  IF ok
     THEN
       BEGIN
	Begruessung ;
	Hauptmenue;
	ciao ;
       END
END.

e (DatGedanken);
     reset (Datsuchen, suchendat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
       THEN BEGIN
	 Anzsuchen := 0;
	 FOR zaehler := 1 TO maxDateiEintraege DO
	   IF NOT eof(Datsuchen)
	     THEN BEGIN
	       readln (Datsuchen, Fsuchen [zaehler]);
	       Anzsuchen := Anzsuchen + 1;
	       END
	     ELSE
	       Fsuchen [zaehler] := ' ';
         END;
     close (Datsuchen);
     reset (DatHilfe, hilfedat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
       THEN BEGIN
	  AnzHilfe := 0;
	  FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(DatHilfe)
	       THEN BEGIN
		 readln (DatHilfe, FHilfe [zaehler]);
		 AnzHilfe := AnzHilfe + 1;
		 END
	       ELSE
		 FHilfe [zaehler] := ' ';
	  END; (* then *)
     CLOSE (DatHilfe);       
     IO_Check (TRUE);
     initgrand;
     rewrite (ausgabe, ausgabedatei);
   END;  (* init *)

(************************************************************************)

   PROCEDURE baueStrophe ( VAR str: tStrophe );
      (* Baut eine Strophe aus den Grunddateien zusammen und uebergibt sie *)
      (* als str.                                                          *)
     VAR zufzahl : integer;

     BEGIN  (* baueStrophe *)
       mein_random (AnzAngst, zufzahl);
       str[1] := FAngst[zufzahl];
       zentriere (str[1]);
       mein_random (Anzvieles, zufzahl);
       str[2] := Fvieles[zufzahl];
       mein_random (Anzstoerend, zufzahl);
       str[2] := concat (str[2], ' ', Fstoerend[zufzahl]);
       zentriere (str[2]);
       mein_random (AnzAngst, zufzahl);
       str[3] := FAngst[zufzahl];
       zentriere (str[3]);
       mein_random (Anzlauernd, zufzahl);
       str[4] := Flauernd[zufzahl];
       mein_random (Anzunter, zufzahl);
       str[4] := concat (str[4], ' ', Funter[zufzahl]);
       mein_random (Anzroten, zufzahl);
       str[4] := concat (str[4], ' ', Froten[zufzahl]);
       mein_random (AnzSonnen, zufzahl);
       str[4] := concat (str[4], ' ', FSonnen[zufzahl]);
       zentriere (str[4]);
       mein_random (Anzich_bin, zufzahl);
       str[5] := Fich_bin[zufzahl];
       mein_random (Anzallein, zufzahl);
       str[5] := concat (str[5], ' ', Fallein[zufzahl]);
       zentriere (str[5]);
       mein_random (AnzGedanken, zufzahl);
       str[6] := FGedanken[zufzahl];
       mein_random (Anzsuchen, zufzahl);
       str[6] := concat (str[6], ' ', Fsuchen[zufzahl]);
       mein_random (AnzHilfe, zufzahl);
       str[6] := concat (str[6], ' ', FHilfe[zufzahl]);
       zentriere (str[6]);
     END;  (* baueStrophe *)

(************************************************************************)

   PROCEDURE baueTitel ( VAR titel: tTitel );
     VAR zufzahl : integer;
	 zaehler : integer;

     BEGIN
       mein_random (AnzTitel, zufzahl);
       titel[1] := FTitel[zufzahl];
       titel[2] := '=';
       FOR zaehler := 2 TO length (titel[1]) DO
       titel[2] := concat (titel[2], '=');
       zentriere (titel[1]);
       zentriere (titel[2]);
       titel[3] := ' ';
     END;

(************************************************************************)

   PROCEDURE spTitel ( titel: tTitel );
     VAR zaehler : 1..2;

     BEGIN
       writeln (ausgabe);
       writeln (ausgabe);
       FOR zaehler := 1 TO 2 DO
	   writeln (ausgabe, titel [zaehler]);
     END;

(************************************************************************)

   PROCEDURE speichereStrophe ( str: tStrophe );
     VAR zaehler : 1..6;     (* Anzahl der Verse ist 6 *)

     BEGIN
       writeln (ausgabe);
       FOR zaehler := 1 TO 6 DO
	   writeln (ausgabe, str[zaehler]);
     END;  (* speichereStrophe *)

(************************************************************************)

   PROCEDURE zeigeTitel ( titel: tTitel );
     VAR zaehler : 1..2;

     BEGIN
       cur_off;
       FOR zaehler := 1 TO 2 DO
	   writeln (titel[zaehler]);
       cur_on;
     END;


(************************************************************************)

   PROCEDURE zeigeStrophe ( str: tStrophe );
      (* zeigt eine Strophe mit fuehrender und nachfolgender Leerzeile     *)
      (* auf dem Bildschirm                                                *)
     VAR zaehler : 1..6;     (* Anzahl der Verse ist 6 *)
     BEGIN
       Cur_off;
       writeln;
       FOR zaehler := 1 TO 6 DO
	   writeln (str[zaehler]);
   atunter );
       close ( Datroten );
       close ( DatSonnen );
       close ( Datich_bin );
       close ( Datallein );
       close ( DatGedanken );
       close ( Datsuchen );
       close ( DatHilfe );
       close ( ausgabe );
     END; (* schliesse *)

