                   (************************************)
                   (*                                  *)
                   (*   Modul Gedichte     	       *)
                   (*   J. v. Waldhausen 10.3.89       *)
                   (*                                  *)
                   (*   A.Schmidt '90, Zusatz zum      *)
                   (*   Speichern von Gedichten        *)
                   (*                                  *)
                   (*   IMPORT: Moduln Cons_typ,       *)
                   (*                  Screen,         *)
                   (*                  Strophen        *)
                   (*                                  *)
		   (************************************)


  PROCEDURE baueGedicht (VAR Ged : tGedicht; AnzStr: tStrproGe);
     VAR
	  index: tStrproGe;
	  strophe : tStrophe;
	  titel : tTitel;

     BEGIN
       FOR index := 1 TO AnzStr DO
	 BEGIN
	   baueStrophe (strophe);
	   Ged[index] := strophe;
	 END;
     END; (* baueGedicht *)

(*************************************************************************)

  PROCEDURE schrGedicht (Ged : tGedicht; AnzStr: tStrproGe);
     VAR
	 index : 1..maxStrophen;
	 strophe : tStrophe;
	 titel : tTitel;

     BEGIN
       loescheBildschirm;
       baueTitel (titel);
       zeigeTitel (titel);
       FOR index := 1 TO AnzStr DO
	   zeigeStrophe ( Ged[index] );
       set_cursor (55, 24);
       write ('Weiter mit <RETURN>');
       readln;
     END;  (* schrGedicht *)

(*************************************************************************)

  PROCEDURE spGedicht (Ged : tGedicht; AnzStr: tStrproGe);
     VAR
	 index : 1..maxStrophen;
	 strophe : tStrophe;
	 titel : tTitel;

     BEGIN
       loescheBildschirm;
       spTitel (titel);
       FOR index := 1 TO AnzStr DO
	   speichereStrophe ( Ged[index] );
     END;  (* spGedicht *)
