                   (************************************)
                   (*                                  *)
                   (*   Modul Cons_Typ     	       *)
                   (*   A.Schmidt '90                  *)
                   (*                                  *)
                   (*   Stellt Konstanten und Typen    *)
                   (*   zur Verfgung                  *)
                   (*                                  *)
                   (*   IMPORT: /		       *)
                   (*                                  *)
		   (************************************)

CONST
	maxStrophen = 3;	    (* Maximale Strophenanzahl *)
	maxDateiEintraege = 20;     (* max. Anzahl von Versbestandteilen *)
		      		    (* je Datei *)
	maxVerse = 6;		    (* max. Anzahlvon Versen je Strophe	*)
	Zeilenlaenge = 40;	    (* Max. Zeilenlnge je Vers *)
	
	(* Die folgenden Konstanten sind betriebssystem- und gedicht- 	*)
	(* spezifisch, also ggfs. anzupassen !				*)
	(* Zunchst die Namen der Versteil-Grunddateien (Eingabe)	*)
	titeldat = '.\dat1\titel.dat';
	angstdat  = '.\dat1\angst.dat';
	vielesdat  = '.\dat1\vieles.dat';
	stoerenddat  = '.\dat1\stoerend.dat';
	lauernddat  = '.\dat1\lauernd.dat';
	unterdat  = '.\dat1\unter.dat';
	rotendat  = '.\dat1\roten.dat';
	sonnendat  = '.\dat1\sonnen.dat';
	ich_bindat  = '.\dat1\ich_bin.dat';
	alleindat  = '.\dat1\allein.dat';
	gedankendat  = '.\dat1\gedanken.dat';
	suchendat  = '.\dat1\suchen.dat';
	hilfedat  = '.\dat1\hilfe.dat';
	(* Jetzt die Ausgabedatei					*)
	ausgabedatei = 'gedicht.txt';

   TYPE
	string12 = STRING[12];
	string20 = STRING[20];
	string40 = STRING[40];
	string60 = STRING[60];
	string2 = STRING[2];
	tStrophe = ARRAY [1..maxVerse] OF string60;
        tGedicht = ARRAY [1..maxStrophen] OF tStrophe;
	tStrproGe = 1..maxStrophen;
        tTitel = ARRAY [1..3] OF string60;   (* Titel + Leerzeile *)
     	

